import { ref, reactive } from 'vue'
import type { CSSProperties } from 'vue'

interface MyMarkInterface {
  style: CSSProperties
  label: string
}
type MyMarkType = Record<number, MyMarkInterface | string>

export const useManyValues = () => {
  const screen = "竖屏";
  const if_need_subtitle = "false";

  const sd_prompt_prefix = `(dressed:1.5),best quality,masterpiece,realistic,HDR,UHD,8K,best quality,highres,absurdres,realistic,masterpiece,
  Highly detailed,extreme detail description,Professional,cinematic_lighting,ultra-fine painting,full body,Vivid Colors,
  physically-based rendering,cinematic,`;

  const sd_negative_prompt_prefix = `multiple breasts, (mutated hands and fingers:1.5), (long body :1.3), 
  (mutation, poorly drawn :1.2) , black-white, bad anatomy, liquid body, liquid tongue, disfigured, 
  malformed, mutated, anatomical nonsense, malformed hands, long neck, blurred, 
  lowers, bad proportions, bad shadow, uncoordinated body, unnatural body, fused breasts, 
  bad breasts, huge breasts, poorly drawn breasts, extra breasts, liquid breasts, heavy breasts, missing breasts, 
  huge haunch, huge thighs, huge calf, bad hands, fused hand, missing hand, disappearing arms, disappearing thigh, 
  disappearing calf, disappearing legs, fused ears, bad ears, poorly drawn ears, extra ears, liquid ears, heavy ears, 
  missing ears, fused animal ears, bad animal ears, poorly drawn animal ears, extra animal ears, liquid animal ears, 
  heavy animal ears, missing animal ears, text, ui, error, missing fingers, missing limb, fused fingers, 
  one hand with more than 5 fingers, one hand with less than 5 fingers, one hand with more than 5 digit, 
  one hand with less than 5 digit, extra digit, fewer digits, fused digit, missing digit, bad digit, liquid digit, 
  colorful tongue, black tongue, cropped, watermark, username, blurry, JPEG artifacts, signature, 3D, 3D game, 
  3D game scene, 3D character, malformed feet, extra feet, bad feet, poorly drawn feet, fused feet, missing feet, 
  extra shoes, bad shoes, fused shoes, more than two shoes, poorly drawn shoes, bad gloves, poorly drawn gloves, 
  fused gloves, bad cum, poorly drawn cum, fused cum, bad hairs, poorly drawn hairs, fused hairs, big muscles, ugly, 
  bad face, fused face, poorly drawn face, cloned face, big face, long face, bad eyes, fused eyes poorly drawn eyes, 
  extra eyes, malformed limbs, more than 2 nipples, missing nipples, different nipples, fused nipples, bad nipples, 
  poorly drawn nipples, black nipples, colorful nipples, gross proportions. short arm, (((missing arms))), missing thighs, 
  missing calf, missing legs, mutation, duplicate, morbid, mutilated, poorly drawn hands, more than 1 left hand, 
  more than 1 right hand, deformed, (blurry), disfigured, missing legs, extra arms, extra thighs, more than 2 thighs, 
  extra calf, fused calf, nsfw,logo,text,extra legs, bad knee, extra knee, more than 2 legs, bad tails, bad mouth, 
  fused mouth, poorly drawn mouth, bad tongue, tongue within mouth, too long tongue, black tongue, big mouth, cracked mouth, 
  bad mouth, dirty face, dirty teeth, dirty pantie, fused pantie, poorly drawn pantie, fused cloth, poorly drawn cloth, bad pantie, 
  yellow teeth, thick lips, bad cameltoe, colorful cameltoe, bad asshole, poorly drawn asshole, fused asshole, missing asshole, 
  bad anus, bad pussy, bad crotch, bad crotch seam, fused anus, fused pussy, fused anus, fused crotch, poorly drawn crotch, 
  fused seam, poorly drawn anus, poorly drawn pussy, poorly drawn crotch, poorly drawn crotch seam, bad thigh gap, missing thigh gap, 
  fused thigh gap, liquid thigh gap, poorly drawn thigh gap, poorly drawn anus, bad collarbone, fused collarbone, missing collarbone, 
  liquid collarbone, obesity, worst quality, low quality, normal quality, liquid tentacles, bad tentacles, poorly drawn tentacles, 
  split tentacles, fused tentacles, missing clit, bad clit, fused clit, colorful clit, black clit, liquid clit, QR code, bar code, censored, 
  safety panties, safety knickers, beard, furry ,pony, pubic hair, mosaic, excrement, faeces, shit, futa, testis,mutated hands and fingers,
  deformed,bad anatomy,disfigured,poorly drawn face,lowres,mutated,extra limb,ugly,poorly drawn hands,missing limb,floating limbs,
  disconnected limbs,malformed hands,out of focus,long neck,long body,gape,`;

  const horizontal_data = {
    task_id: "20240209114425596",
    chatgpt_prompt: `生成一个100字的小故事`,
    chatgpt_answer: `从前有一个小男孩名叫小明，他非常喜欢冒险和探险。一天，他听说镇上的老教堂有一个传说中的宝藏。于是，小明决定前往探寻宝藏的秘密。他兴奋地穿过了一个森林，越过了一条湍急的河流，终于来到了老教堂的门前。教堂里昏暗而阴森，小明开始在各个角落寻找宝藏。他翻遍了教堂的每一个房间，甚至爬上了教堂的钟楼，但是却没有找到宝藏的踪迹。慢慢地，小明感到失望和沮丧。正当他准备离开时，他发现了一个看似普通的石头。他突然有了一种直觉，将石头掀开，竟然发现了一道秘密通道！小明毫不犹豫地走了进去，迎接他的是散发着金光的宝藏。小明高兴地抱起宝藏，回到家中。从那天起，他决定要成为一个伟大的探险家，为世界带来更多的惊喜和宝藏。`,
    chatgpt_answer_roles: [{"角色": "小明",  "角色关键词": "小男孩, 性别: 男, 年龄: 10岁, 肤色: 黄色, 衣服: 破旧的牛仔裤和绿色T恤, 发型: 短发, 发色: 乌黑, 脸色: 健康的小麦色, 五官特点: 大眼睛炯炯有神, 高鼻梁, 嘴角总是挂着微笑"}],
    adapt_result_json: [
      {
          "编号": "1",
          "场景描述": "从前有一个小男孩名叫小明，他非常喜欢冒险和探险",
          "场景关键词": "小男孩,冒险,探险",
          "角色": "小明",
          "角色关键词": "男性,年轻,普通衣服,普通发型,正常肤色,兴奋的情绪,活力的体态",
          "画面描述词": "Once upon a time, there was a young boy named Xiaoming. He had a burning passion for adventure and exploration, always longing to embark on thrilling quests. Xiaoming was an ordinary boy, with a lively spirit and a sense of excitement that radiated from him. He had a typical appearance, with a youthful face, regular clothes, and a simple hairstyle. His skin had a normal complexion, and he exuded a vibrant energy in his every movement. Xiaoming's heart was constantly brimming with curiosity and eagerness to discover the unknown, making him a true adventurer at heart.",
          "本镜配图": "http://wm_tools_backend.frp.wmdigit.com:8888/assets/outputs/20240209114425596/img/1.png?v=20240209114451753",
          "local_image_path": "assets/outputs/20240209114425596/img/1.png"
      },
      {
          "编号": "2",
          "场景描述": "一天，他听说镇上的老教堂有一个传说中的宝藏",
          "场景关键词": "镇上,老教堂,宝藏",
          "角色": "小明",
          "角色关键词": "男孩,小明",
          "画面描述词": "One day, he heard about a legendary treasure hidden in the old church in town. Excitement filled his heart as he imagined the possibilities. Determined to uncover the truth, young boy named Xiao Ming embarked on an adventure that would take him to the heart of the town. The old church stood tall, its weathered stones whispering stories of centuries past. Inside, he could feel the ancient aura beckoning him further, as if guiding him towards the secrets that lay within. With each step, the anticipation grew, and the flickering light from his flashlight danced on the walls, casting eerie shadows. The air was heavy with anticipation, as Xiao Ming's heart raced with both thrill and uncertainty. Little did he know, this quest for the treasure would not only test his courage, but also reveal the true essence of his spirit.",
          "本镜配图": "http://wm_tools_backend.frp.wmdigit.com:8888/assets/outputs/20240209114425596/img/2.png?v=20240209114500766",
          "local_image_path": "assets/outputs/20240209114425596/img/2.png"
      }
    ],
    final_video: "http://wm_tools_backend.frp.wmdigit.com:8888/assets/outputs/20240209114425596/final_video.mp4",
  };

  const vertical_data = {
    task_id: "20240220181602687",
    chatgpt_prompt: `生成一个100字的科幻小故事，阿凡达系列`,
    chatgpt_answer: ``,
    chatgpt_answer_roles: [],
    adapt_result_json: [],
    final_video: ``,
  };

  const en_vertical_data = {
    task_id: "20240225222232784",
    chatgpt_prompt: `Generate a 100 word science fiction short story, Avatar series`,
    chatgpt_answer: ``,
    chatgpt_answer_roles: [],
    adapt_result_json: [],
    final_video: ``,
  };

  const marks = reactive<MyMarkType>({
    '-100': '-100%',
    '-90': '-90%',
    '-80': '-80%',
    '-70': '-70%',
    '-60': '-60%',
    '-50': '-50%',
    '-40': '-40%',
    '-30': '-30%',
    '-20': '-20%',
    '-10': '-10%',
    0: '0',
    10: '+10%',
    20: '+20%',
    30: '+30%',
    40: '+40%',
    50: '+50%',
    60: '+60%',
    70: '+70%',
    80: '+80%',
    90: '+90%',
    100: '+100%',
  })
  const voices = [
    {
      value: 'zh-CN-liaoning-XiaobeiNeural',
      gender: 'Female',
      label: '女，东北口音',
    },
    {
      value: 'zh-CN-shaanxi-XiaoniNeural',
      gender: 'Female',
      label: '女，陕西口音',
    },
    {
      value: 'zh-CN-XiaoxiaoNeural',
      gender: 'Female',
      label: '女，像个老师',
    },
    {
      value: 'zh-CN-XiaoyiNeural',
      gender: 'Female',
      label: '女，小女孩',
    },
    {
      value: 'zh-CN-YunjianNeural',
      gender: 'Male',
      label: '男，成熟稳重',
    },
    {
      value: 'zh-CN-YunxiaNeural',
      gender: 'Male',
      label: '男，小男孩',
    },
    {
      value: 'zh-CN-YunxiNeural',
      gender: 'Male',
      label: '男，大哥哥',
    },{
      value: 'zh-CN-YunyangNeural',
      gender: 'Male',
      label: '男，像个播音员',
    },{
      value: 'zh-HK-HiuGaaiNeural',
      gender: 'Female',
      label: '女，粤语，中年',
    },{
      value: 'zh-HK-HiuMaanNeural',
      gender: 'Female',
      label: '女，粤语，年轻',
    },{
      value: 'zh-HK-WanLungNeural',
      gender: 'Male',
      label: '男，粤语',
    },{
      value: 'zh-TW-HsiaoChenNeural',
      gender: 'Female',
      label: '女，台湾腔',
    },{
      value: 'zh-TW-HsiaoYuNeural',
      gender: 'Female',
      label: '女，台湾，偏普通话',
    },{
      value: 'zh-TW-YunJheNeural',
      gender: 'Male',
      label: '男，台湾腔',
    },
  ]

  const bgm = [
    {
      value: '',
      label: '无',
    },
    {
      value: '安魂曲',
      label: '安魂曲',
    },
    {
      value: '解忧曲',
      label: '解忧曲',
    },
    {
      value: 'Anacreon',
      label: 'Anacreon',
    },
    {
      value: 'MySunset',
      label: 'MySunset',
    },
    {
      value: 'WindyHill',
      label: 'WindyHill',
    },
  ]
  
  return {
    screen: screen,
    sd_prompt_prefix: sd_prompt_prefix,
    sd_negative_prompt_prefix: sd_negative_prompt_prefix,
    horizontal_data: horizontal_data,
    vertical_data: vertical_data,
    if_need_subtitle: if_need_subtitle,
    en_vertical_data: en_vertical_data,
    marks: marks,
    voices: voices,
    bgm: bgm,
  }
}
